// Test pattern generator for DAC902
// push 16 values in via host, this block will address them at 80 MS/s

`timescale 1ns / 1ns
module srl16x12e(Q, A0, A1, A2, A3, CE, CLK, D);
	input A0, A1, A2, A3, CE, CLK;
	input  [11:0] D;
	output [11:0] Q;
	wire   [11:0] Q, D;
	SRL16E d0(.Q(Q[0]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[0]));
	SRL16E d1(.Q(Q[1]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[1]));
	SRL16E d2(.Q(Q[2]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[2]));
	SRL16E d3(.Q(Q[3]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[3]));
	SRL16E d4(.Q(Q[4]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[4]));
	SRL16E d5(.Q(Q[5]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[5]));
	SRL16E d6(.Q(Q[6]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[6]));
	SRL16E d7(.Q(Q[7]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[7]));
	SRL16E d8(.Q(Q[8]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[8]));
	SRL16E d9(.Q(Q[9]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[9]));
	SRL16E d10(.Q(Q[10]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[10]));
	SRL16E d11(.Q(Q[11]), .A0(A0), .A1(A1), .A2(A2), .A3(A3), .CE(CE), .CLK(CLK), .D(D[11]));
endmodule

module dac_testpattern(clk80, dac_out, load_data, clk_host, we);
	input  clk80, clk_host, we;
	wire   clk80, clk_host, we;
	output [11:0] dac_out;
	reg    [11:0] dac_out;
	input  [15:0] load_data;
	wire   [15:0] load_data;
	reg [3:0] cnt;
	always @(posedge clk80) cnt <= cnt + 1'b1;
`ifdef SIMULATE
	initial cnt = 0;
`endif
	wire [11:0] srl_out;
	srl16x12e bank(.Q(srl_out), .A0(cnt[0]), .A1(cnt[1]), .A2(cnt[2]),  .A3(cnt[3]),
		.CE(we), .CLK(clk_host), .D(load_data[15:4]));
	always @(posedge clk80) dac_out <= srl_out;
endmodule
