// Verilog ramdp1024x12 definition
// No copyright is claimed on this machine-generated code.
// Automatically generated from perl bram.pl 12 10
// bram.pl is Copyright (C) 2002 Larry Doolittle <larry@doolittle.boa.org>

// 1024 x 12 dual port RAM, aggregated from
// 3 instances of 1024 x 4 Virtex Block RAM

`timescale 1ns / 1ns

module ramdp1024x12(
	ADDRA, RSTA, ENA, WEA, CLKA, DIA, DOA,
	ADDRB, RSTB, ENB, WEB, CLKB, DIB, DOB);

input  [9:0] ADDRA;
input  RSTA, ENA, WEA, CLKA;
input  [11:0] DIA;
output [11:0] DOA;

input  [9:0] ADDRB;
input  RSTB, ENB, WEB, CLKB;
input  [11:0] DIB;
output [11:0] DOB;

wire   [9:0] ADDRA;
wire   RSTA, ENA, WEA, CLKA;
wire   [11:0] DIA;
wire   [11:0] DOA;

wire   [9:0] ADDRB;
wire   RSTB, ENB, WEB, CLKB;
wire   [11:0] DIB;
wire   [11:0] DOB;

RAMB4_S4_S4 b0(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[3:0]),
	.DOA   (DOA[3:0]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[3:0]),
	.DOB   (DOB[3:0])
);

RAMB4_S4_S4 b1(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[7:4]),
	.DOA   (DOA[7:4]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[7:4]),
	.DOB   (DOB[7:4])
);

RAMB4_S4_S4 b2(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[11:8]),
	.DOA   (DOA[11:8]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[11:8]),
	.DOB   (DOB[11:8])
);

endmodule
