// Verilog ramdp1024x32 definition
// No copyright is claimed on this machine-generated code.
// Automatically generated from perl bram.pl 32 10
// bram.pl is Copyright (C) 2002 Larry Doolittle <larry@doolittle.boa.org>

// 1024 x 32 dual port RAM, aggregated from
// 8 instances of 1024 x 4 Virtex Block RAM

`timescale 1ns / 1ns

module ramdp1024x32(
	ADDRA, RSTA, ENA, WEA, CLKA, DIA, DOA,
	ADDRB, RSTB, ENB, WEB, CLKB, DIB, DOB);

input  [9:0] ADDRA;
input  RSTA, ENA, WEA, CLKA;
input  [31:0] DIA;
output [31:0] DOA;

input  [9:0] ADDRB;
input  RSTB, ENB, WEB, CLKB;
input  [31:0] DIB;
output [31:0] DOB;

wire   [9:0] ADDRA;
wire   RSTA, ENA, WEA, CLKA;
wire   [31:0] DIA;
wire   [31:0] DOA;

wire   [9:0] ADDRB;
wire   RSTB, ENB, WEB, CLKB;
wire   [31:0] DIB;
wire   [31:0] DOB;

RAMB4_S4_S4 b0(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[3:0]),
	.DOA   (DOA[3:0]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[3:0]),
	.DOB   (DOB[3:0])
);

RAMB4_S4_S4 b1(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[7:4]),
	.DOA   (DOA[7:4]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[7:4]),
	.DOB   (DOB[7:4])
);

RAMB4_S4_S4 b2(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[11:8]),
	.DOA   (DOA[11:8]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[11:8]),
	.DOB   (DOB[11:8])
);

RAMB4_S4_S4 b3(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[15:12]),
	.DOA   (DOA[15:12]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[15:12]),
	.DOB   (DOB[15:12])
);

RAMB4_S4_S4 b4(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[19:16]),
	.DOA   (DOA[19:16]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[19:16]),
	.DOB   (DOB[19:16])
);

RAMB4_S4_S4 b5(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[23:20]),
	.DOA   (DOA[23:20]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[23:20]),
	.DOB   (DOB[23:20])
);

RAMB4_S4_S4 b6(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[27:24]),
	.DOA   (DOA[27:24]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[27:24]),
	.DOB   (DOB[27:24])
);

RAMB4_S4_S4 b7(
	.ADDRA (ADDRA),
	.RSTA  (RSTA),
	.ENA   (ENA),
	.WEA   (WEA),
	.CLKA  (CLKA),
	.DIA   (DIA[31:28]),
	.DOA   (DOA[31:28]),

	.ADDRB (ADDRB),
	.RSTB  (RSTB),
	.ENB   (ENB),
	.WEB   (WEB),
	.CLKB  (CLKB),
	.DIB   (DIB[31:28]),
	.DOB   (DOB[31:28])
);

endmodule
